# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_pick_client/ItemModel.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import rc_pick_client.msg

class ItemModel(genpy.Message):
  _md5sum = "ef59d01bffdac79d4a60441b2ea1f3f8"
  _type = "rc_pick_client/ItemModel"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Definition of an item model for the itempick component

# Required
string type

# Supported types
string UNKNOWN=UNKNOWN
string RECTANGLE=RECTANGLE

# Only one of those required depending on the selected type
# In case of unknown type, these values defines an optional bounding box for the item
RangeBox unknown
RangeRectangle rectangle

================================================================================
MSG: rc_pick_client/RangeBox
# Definition of a box with minimum and maximum dimensions

Box min_dimensions
Box max_dimensions

================================================================================
MSG: rc_pick_client/Box
# Definition of a box

float64 x
float64 y
float64 z

================================================================================
MSG: rc_pick_client/RangeRectangle
# Definition of a rectangle with minimum and maximum dimensions

Rectangle min_dimensions
Rectangle max_dimensions

================================================================================
MSG: rc_pick_client/Rectangle
# Definition of a rectangle

float64 x
float64 y
"""
  # Pseudo-constants
  UNKNOWN = 'UNKNOWN'
  RECTANGLE = 'RECTANGLE'

  __slots__ = ['type','unknown','rectangle']
  _slot_types = ['string','rc_pick_client/RangeBox','rc_pick_client/RangeRectangle']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       type,unknown,rectangle

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ItemModel, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.type is None:
        self.type = ''
      if self.unknown is None:
        self.unknown = rc_pick_client.msg.RangeBox()
      if self.rectangle is None:
        self.rectangle = rc_pick_client.msg.RangeRectangle()
    else:
      self.type = ''
      self.unknown = rc_pick_client.msg.RangeBox()
      self.rectangle = rc_pick_client.msg.RangeRectangle()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_10d().pack(_x.unknown.min_dimensions.x, _x.unknown.min_dimensions.y, _x.unknown.min_dimensions.z, _x.unknown.max_dimensions.x, _x.unknown.max_dimensions.y, _x.unknown.max_dimensions.z, _x.rectangle.min_dimensions.x, _x.rectangle.min_dimensions.y, _x.rectangle.max_dimensions.x, _x.rectangle.max_dimensions.y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.unknown is None:
        self.unknown = rc_pick_client.msg.RangeBox()
      if self.rectangle is None:
        self.rectangle = rc_pick_client.msg.RangeRectangle()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.type = str[start:end].decode('utf-8')
      else:
        self.type = str[start:end]
      _x = self
      start = end
      end += 80
      (_x.unknown.min_dimensions.x, _x.unknown.min_dimensions.y, _x.unknown.min_dimensions.z, _x.unknown.max_dimensions.x, _x.unknown.max_dimensions.y, _x.unknown.max_dimensions.z, _x.rectangle.min_dimensions.x, _x.rectangle.min_dimensions.y, _x.rectangle.max_dimensions.x, _x.rectangle.max_dimensions.y,) = _get_struct_10d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_10d().pack(_x.unknown.min_dimensions.x, _x.unknown.min_dimensions.y, _x.unknown.min_dimensions.z, _x.unknown.max_dimensions.x, _x.unknown.max_dimensions.y, _x.unknown.max_dimensions.z, _x.rectangle.min_dimensions.x, _x.rectangle.min_dimensions.y, _x.rectangle.max_dimensions.x, _x.rectangle.max_dimensions.y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.unknown is None:
        self.unknown = rc_pick_client.msg.RangeBox()
      if self.rectangle is None:
        self.rectangle = rc_pick_client.msg.RangeRectangle()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.type = str[start:end].decode('utf-8')
      else:
        self.type = str[start:end]
      _x = self
      start = end
      end += 80
      (_x.unknown.min_dimensions.x, _x.unknown.min_dimensions.y, _x.unknown.min_dimensions.z, _x.unknown.max_dimensions.x, _x.unknown.max_dimensions.y, _x.unknown.max_dimensions.z, _x.rectangle.min_dimensions.x, _x.rectangle.min_dimensions.y, _x.rectangle.max_dimensions.x, _x.rectangle.max_dimensions.y,) = _get_struct_10d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_10d = None
def _get_struct_10d():
    global _struct_10d
    if _struct_10d is None:
        _struct_10d = struct.Struct("<10d")
    return _struct_10d
